
echo "Inside Chroot Env"
echo
source /environment.sh
pwd
echo
echo ${PASSWORD}
echo ${USER}
echo ${DISK}


echo "Installing Important Packages"

mkinitcpio -P

#install from lists
gpg --refresh-keys
pacman-key --init && pacman-key --populate
pacman-key --refresh-keys
pacman -Syy

pacman -S --noconfirm man-pages man-db dnsutils ethtool iputils net-tools iproute2 openssh wget \
usbutils usb_modeswitch tcpdump smartmontools  gnu-netcat mc dosfstools exfat-utils \
partclone parted partimage gptfdisk iw dialog base-devel vim \
grub os-prober efivar efibootmgr efitools intel-ucode amd-ucode dmidecode htop nano python

# future use
#pacman -S --noconfirm slurm-llnl

cd /usr/bin/
ln -s vim vi

echo "Setup Timezone and Locale"

ln -sf /usr/share/zoneinfo/Europe/Prague /etc/localtime

hwclock --systohc

echo "en_GB.UTF-8 UTF-8" >> /etc/locale.gen
locale-gen
echo "LANG=en_GB.UTF-8" >> /etc/locale.conf

echo "Network Setup"

dmidecode --string system-uuid | cut -c1-8 > /etc/hostname

echo "127.0.0.1	localhost" > /etc/hosts
echo "::1		localhost" >> /etc/hosts

# for IPv6:
# DHCP=yes

echo "[Match]"         > /etc/systemd/network/20-wired.network
echo "Name=${NET}"     >> /etc/systemd/network/20-wired.network
echo ""                >> /etc/systemd/network/20-wired.network
echo "[Network]"       >> /etc/systemd/network/20-wired.network
echo "DHCP=ipv4"       >> /etc/systemd/network/20-wired.network
echo ""                >> /etc/systemd/network/20-wired.network
echo "[DHCPv6]"        >> /etc/systemd/network/20-wired.network
echo "UseDomains=true" >> /etc/systemd/network/20-wired.network

echo "Adding Users"

groupadd wheel
groupadd sudo

useradd -m -G users,sudo -s /bin/bash ${USER}
yes ${PASSWORD} | passwd
yes ${PASSWORD} | passwd ${USER}

echo "%sudo ALL=(ALL:ALL) ALL" >> /etc/sudoers
echo "%wheel ALL=(ALL:ALL) NOPASSWD: ALL" >> /etc/sudoers

echo "Installing GRUB"

mkdir /boot/grub
grub-mkconfig -o /boot/grub/grub.cfg
grub-install ${DISK}


echo "Enabling services"
systemctl enable systemd-networkd
systemctl enable systemd-resolved
systemctl enable systemd-timesyncd
systemctl enable sshd

timedatectl set-timezone $timezone
timedatectl set-ntp true

echo "Generating issue"

echo "             ___       ,-\`."             >  /etc/issue
echo "         .-~~   ~~-.,-~ _~ "              >> /etc/issue
echo "       #\`           \`._-   "            >> /etc/issue
echo "      .\`           _-~.    "             >> /etc/issue
echo "      |          _-   |    "              >> /etc/issue
echo "      \`       _-~     '    "             >> /etc/issue
echo "  . _-~\`. _-~       .'     "             >> /etc/issue
echo " ,-' _,-~\`-__   __-'       "             >> /etc/issue
echo ",.-~\`   .    ~~~           "             >> /etc/issue
echo "                           "              >> /etc/issue
echo "        SatrunArch         "              >> /etc/issue
echo                                            >> /etc/issue
echo "IP Addresses:"                            >> /etc/issue
echo "    \\4"                                  >> /etc/issue
echo "    \\6"                                  >> /etc/issue
echo                                            >> /etc/issue
echo "Default login:"                           >> /etc/issue
echo "    user: ${USER}"                        >> /etc/issue
echo "    pass: ${PASSWORD}"                    >> /etc/issue
echo                                            >> /etc/issue


echo "Exiting Chroot Environment"

exit

